$tagmode = 0; 							//0 is for no tag mode, 1 is for standard, 2 is for culmlitive 
$tagmodenames[1] = "Standard";
$tagmodenames[2] = "Last man standing";
$tagmodenames[3] = "Freeze";

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
if(!$RTB::ServerControl_Hook)
exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
RTB_registerPref("Let players suicide during a tag game? ","DrenDran","$tagcansuicide","bool","Gamemode_Tag",true,0,0);
}
else
$tagcansuicide = 1;

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
if(!$RTB::ServerControl_Hook)
exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
RTB_registerPref("Let players leave a tag game? ","DrenDran","$tagcanleave","bool","Gamemode_Tag",true,0,0);
}
else
$tagcanleave = 1;


datablock PlayerData(PlayerFrozenArmor : PlayerStandardArmor)
{
   runForce = 0;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 0;
   maxBackwardSpeed = 0;
   maxSideSpeed = 0;

   maxForwardCrouchSpeed = 0;
   maxBackwardCrouchSpeed = 0;
   maxSideCrouchSpeed = 0;

   jumpForce = 0;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	
	rechargeRate = 0;

	uiName = "Frozen Player";
	showEnergyBar = true;

   runSurfaceAngle  = 0;
   jumpSurfaceAngle = 0;
};


deactivatepackage(DDtag);
package DDtag //the main and only package
{
	function serverCmdsuicide(%client)
	{
	if($tagmode == 0 || $tagcansuicide)
	%client.player.kill();
	}

	function GameConnection::onClientEnterGame(%client)
	{
	parent::onClientEnterGame(%client);
	if($tagmode == 1)
	messageclient(%client,'',"A standard tag game is in progress.");
	if($tagmode == 2)
	messageclient(%client,'',"A last man standing tag game is in progress.");
	if($tagmode == 3)
	messageclient(%client,'',"A freeze tag game is in progress.");
	}

    	function GameConnection::onClientLeaveGame(%this)
    	{
		if(%this.isit)
		{
		if($tagmode == 1)
		{
		messageall('',"The only tagger has left the game, restarting.");
		DDstarttaggame(1);
		}
		else if($tagmode == 3)
		{
		messageall('',"The only tagger has left the game, restarting.");
		DDstarttaggame(3);
		}
		}
		parent::onClientLeaveGame(%this);
    	}


	function Player::activateStuff(%player) 			//when a player is clicked
	{
		Parent::activateStuff(%player); 			//do the normal stuff first
		%target = containerRayCast(%player.getEyePoint(), vectorAdd(vectorScale(vectorNormalize(%player.getEyeVector()), 5), %player.getEyePoint()), $typeMasks::playerObjectType,%player);
      		%clicked = %target.client;
		%clicker = %player.client;
		
		if(%clicker.isPlaying)
		{

		if(!%clicker.isit && %clicker.name !$= %clicked.name && isObject(%clicked) && %clicked.frozen && !%clicker.frozen)
		{
		%clicked.frozen = false;
		%clicked.player.changedatablock("PlayerStandardArmor");
		%clicked.player.setShapeNameColor(%clicked,"");
		messageall('',"\c0" @ %clicked.name @ "\c1 is now unfrozen.");
		}


		if(%clicker.isit && %clicker.name !$= %clicked.name && isObject(%clicked))				//if the person who clicked is one of, or just the one, tagger
		{

		if($tagmode == 1 && %clicked.isPlaying)				//if we're playing standard mode
		{

			if(%clicker.lasttag !$= %clicked.name)		//if the person the clicker is tagging didn't just tag him
			{
				%clicker.isit = false;				//clicker is no longer the tagger
				%clicked.isit = true;				//the clicked person is
				%clicked.lasttag = %clicker.name;
				%clicked.player.setShapeNameColor(%clicked,"");
				%clicker.player.setShapeNameColor(%clicker,"");
				messageall('',"\c0" @ %clicker.name @ "\c1 has tagged \c0" @ %clicked.name @ "\c1.");
			}
		
			else
				messageclient(%clicker,'',"No tag backs!");	//This is so two people just don't go back and forth
		
		}
		
		else if($tagmode == 2 && %clicked.isPlaying)				//if we're playing culimitive
		{
		if(%clicked.isit)
			messageclient(%clicker,'',"He's already it!");
		else
		{
			%clicked.isit = true;				//he's part of the taggers
			messageall('',"\c0" @ %clicked.name @ "\c1 is now also a tagger.");
			%clicked.player.setShapeNameColor(%clicked,"");

			%isallit = true;

					for(%i = 0;%i < ClientGroup.getCount();%i++)
					{
					%client = ClientGroup.getObject(%i);
					if(!%client.isit && isObject(%client.player))%isallit = false;
					}

			if(%isallit)
			{
			messageall('',"Everyone has been tagged! Resetting game!");
			schedule(1000,0,DDstarttaggame,2);
			}

		}
		}

		else if($tagmode == 3 && !%clicked.frozen && !%clicked.isit && %clicked.isPlaying)
		{
			%clicked.frozen = true;
			messageall('',"\c0" @ %clicked.name @ "\c1 is now frozen.");
			%clicked.player.setShapeNameColor(%clicked,"");
			%isallfroze = true;
			%clicked.player.changedatablock("PlayerFrozenArmor");
			%clicked.player.setVelocity("0 0 0");
					for(%i = 0;%i < ClientGroup.getCount();%i++)
					{
					%client = ClientGroup.getObject(%i);
					if(!%client.frozen && !%client.isit && isObject(%client.player))%isallfroze = false;
					}		

			if(%isallfroze)	
			{
			messageall('',"Everyone is frozen! Resetting game!");
			schedule(1000,0,DDstarttaggame,3);
			}
		

		}
		else if(%clicker.name $= %clicked.name)
			messageclient(%clicker,'',"You can't tag yourself.");
		}
	}
}

function player::setShapeNameColor(%this, %color)	//setting the players name
	{
		%client = %this.client;
		//if(isObject(%client = %this.client) && isObject(%client.player) && %this.getState() !$= "dead")  //if player exists and is alive
			//{
			if(%client.isit && ($tagmode == 1 || $tagmode == 3))	//if the player is it and we're playing standard style
				%color = "1 0 0 1";		//set name over head to red, because they're the only tagger
			else if(%client.isit && $tagmode == 2)	//if player is it and we're playing culimitive style tag
				%color = "1 0.647 0 1";		//set name over head to orange, beacuse there are other taggers too
			else if(%client.frozen && $tagmode == 3)
				%color = "0 0 1 1";
			else					//if they're not it, or we're not playing tag
				%color = "1 1 1 1";		//keep name white
		//}
		parent::setShapeNameColor(%this, %color);	//continue as normal
	}


function badtagcheck(%client)
{
if(%client.lasttag $= "")
DDstarttaggame($tagmode);
}

function serverCmdleavetaggame(%client)
{
if($tagcanleave)
{
if(!%client.isit)
%client.isPlaying = false;
else
messageClient(%client,'',"You can't leave if you're a tagger.");
}
else
messageclient(%client,'',"Players aren't allowed to leave tag games.");
}

function DDstarttaggame(%type)					//this function sets the tagmode choses a random person to be it and tells everyone the game is started
{
	$tagmode = %type;					//this assumes the type is already checked for validity
	messageall('',"A new tag game has been started of type \c2" @ $tagmodenames[%type] @ "\c0!");
	PlayerStandardArmor.canJet = 0;
				
	for(%i = 0;%i < ClientGroup.getCount();%i++)
	{
		%client = ClientGroup.getObject(%i);
		%client.isit = false;				//gotta make sure who ever was it last game isn't it anymore
		%client.isPlaying = true;
		%client.lasttag = "";
		%client.frozen = false;
		if(isObject(%client.player))
		{
		%client.player.setShapeNameColor(%client,"");
		%client.player.changedatablock("PlayerStandardArmor");
		}
	}

	%client = ClientGroup.getObject(getRandom(0,ClientGroup.getCount()-1));	//select a random person
	%client.isit = true;					//make him it
	if(isObject(%client.player))
	%client.player.setShapeNameColor(%client,"");
	messageall('',%client.name @ " is the first tagger!");	//and tell everyone about it


	//schedule(120000,0,badtagcheck,%client);		
}

function serverCmdstarttaggame(%client,%type)			//command to start a tag game
{
	if(%client.isAdmin || %client.isSuperAdmin)		//you gotta be admin to start a tag game
	{
		if($tagmode == 0)				//if there isn't a tag game already in progress
		{
			if(%type < 4 && %type > 0)		//if the tag type is valid
			{
				DDstarttaggame(%type);		//set the tag type
			}
			else
				messageclient(%client,'',"At the moment that is a invalid tag mode number.");
		}
		else
			messageclient(%client,'',"Stop the current game of tag first.");
	}
	else
		messageclient(%client,'',"You must be at least admin to do this.");
}

function serverCmdstoptaggame(%client)				//the way to stop the game is fairly simple
{
	if(%client.isAdmin || %client.isSuperAdmin)		//if they are admin
	{
		if($tagmode != 0)
		{
		$tagmode = 0;					//set tagmode to 0
		messageall('',"Tag game ended.");		//and tell everyone		
		PlayerStandardArmor.canJet = 1;
		for(%i = 0;%i < ClientGroup.getCount();%i++)
		{
		%client = ClientGroup.getObject(%i);
		%client.isit = false;				//gotta make sure who ever was it last game isn't it anymore
		%client.lasttag = "";
		if(isObject(%client.player))
		{
		%client.player.setShapeNameColor(%client,"");
		%client.player.changedatablock("PlayerStandardArmor");
		}
		%client.frozen = false;
		}
		}

		else
			messageclient(%client,'',"There is no tag game in progress!");

	}
	else
		messageclient(%client,'',"You must be admin to do that.");
}


function serverCmdaddtagger(%clienta,%name)
{
if(%clienta.isSuperAdmin || %clienta.isAdmin)
{
%client = findclientbyname(%name);
%client.isit = true;
%client.frozen = false;
%client.player.setShapeNameColor(%client,"");
%client.player.changedatablock("PlayerStandardArmor");
messageall('',%clienta.name SPC "\c4has made\c0" SPC %client.name SPC "\c4 a tagger.");
}
}

function serverCmdaddnormal(%clienta,%name)
{
if(%clienta.isSuperAdmin || %clienta.isAdmin)
{
%client = findclientbyname(%name);
%client.isit = false;
%client.frozen = false;
%client.player.setShapeNameColor(%client,"");
%client.player.changedatablock("PlayerStandardArmor");
messageall('',%clienta.name SPC "\c4has made\c0" SPC %client.name SPC "\c4 normal.");
}
}

function serverCmdaddfrozen(%clienta,%name)
{
if(%clienta.isSuperAdmin || %clienta.isAdmin)
{
%client = findclientbyname(%name);
%client.isit = false;
%client.frozen = true;
%client.player.setShapeNameColor(%client,"");
%client.player.changedatablock("PlayerFrozenArmor");
messageall('',%clienta.name SPC "\c4has made\c0" SPC %client.name SPC "\c4 frozen.");
}
}


};
activatepackage(DDtag);
